/**
 * 
 */
	
function tc_getQueryVariable( variable ) {

	var query = window.location.search.substring(1);
	var vars = query.split("&");
	for ( var i = 0; i < vars.length; i++ ) {
		var pair = vars[i].split( "=" );
		if ( pair[0] == variable ) { return pair[1]; }
	}
	return "";
	
}

/**
 *
 */

function tc_getRootUrl() {
	
	var host = ( window.location.protocol + "//" + window.location.host );
	var parts = window.location.href.split( "?" )[0].substr( host.length ).split( "/" );
	var url = "";
	
	for ( var i = 0; i < parts.length; i++ ) {
		if ( parts[i] == "" ) continue;
		if ( parts[i].indexOf(".") > -1 ) {
			break;
		} else {
			url += "/" + parts[i];
		}
	}
	
	return host + url + "/";
	
}

/**
 *
 */

function tc_unfocusAllInputs() {
	
	//console.log("Checking", document.activeElement, document.activeElement.tagName );
	
	if ( document.activeElement.tagName == "INPUT" ) { 
		
		setTimeout( function() {
			
			var field = document.createElement("input");
			field.setAttribute("type", "text");
			field.setAttribute('style', 'position:absolute; top: 0px; opacity: 0; -webkit-user-modify: read-write-plaintext-only; left:0px;');
			document.body.appendChild( field );
			
			field.onfocus = function() {
				setTimeout( function() {
					field.setAttribute("style", "display:none");
					setTimeout( function() {
						document.body.removeChild( field );
						document.body.focus();
					}, 14 );
				}, 200 );
			}
			
			field.focus();
		
		}, 50 );
		
	}
}

/**
 *
 */
 
function tc_copyToClipboard( elId ) {
	var el = document.getElementById( elId );
	el.select();
	el.setSelectionRange(0, 9999);
	document.execCommand("copy");
	document.activeElement.blur();
	document.getSelection().removeAllRanges();
}

/**
 * Setup the Google analytics
 */
var tcGACode = '';
var tcGADim1 = '';
var tcGADim2 = '';
var tcGADim3 = '';

var clientGACode = '';

function tc_initAnalytics() {
	if( tcGACode != '') {
		ga('create', tcGACode, 'auto'); 
		if( tcGADim1 != '' ) ga('set', 'dimension1', tcGADim1);
		if( tcGADim2 != '' ) ga('set', 'dimension2', tcGADim2);
		if( tcGADim3 != '' ) ga('set', 'dimension3', tcGADim3);
		ga('send', 'pageview');
	}
	if( clientGACode != '') {
		ga('create', clientGACode, 'auto', 'clientTracker');
		ga('clientTracker.send', 'pageview');
	}
}

/**
 * Call analytics
 * @author Simon, Tim
 */

function tc_trackAnalyticsEvent( category, action, label, value ) {
	if( tcGACode != '') {
		ga( 'send' , 'event' , category , action, label, value );
	}
	if( clientGACode != '') {
		ga( 'clientTracker.send' , 'event' , category , action, label, value );
	}
}

/**
 * Cookie stuff
 **/
 
function tc_setCookie( name, value ) {
	var d = new Date();
	d.setTime( d.getTime() + ( 1000 * 24 * 60 * 60 * 30 ) );
	var expires = "expires=" + d.toUTCString();
	document.cookie = name + "=" + value + "; " + expires;
}

function tc_getCookie( name ) {
	var name = name + "=";
	//console.log( "Cookie:\n" + document.cookie );
	var ca = document.cookie.split(';');
	for( var i = 0; i < ca.length; i++ ) {
		var c = ca[i];
		
		while ( c.charAt(0) == ' ' ) {
			c = c.substring(1);
		}
		//console.log( "Checking: " + c );
		if ( c.indexOf( name ) == 0 ) {
			return c.substring( name.length, c.length );
		}
	}
	return "";
}

/** Language stuff **/
var tcLang = 'en';
function tc_getLang() {
	return tcLang;
}